/* TCPechod.cpp - main, TCPechod */

#include <stdio.h>
#include <winsock.h>
#include <process.h>
#include "errexit.h"

#define	STKSIZE		16536
#define	BUFSIZE		4096
#define	WSVERS		MAKEWORD(2, 0)

SOCKET	msock;		/* master socket	*/


SOCKET passiveUDP(const char *service);



/*------------------------------------------------------------------------
 * main - Iterative server for ECHO service
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
	char	buf[BUFSIZE];
	char	*service = "echo";	/* service name or port number	*/
	struct	sockaddr_in fsin;	/* the address of a client	*/
	int	alen;			/* length of client's address	*/
	WSADATA	wsadata;


	switch (argc) {
	case	1:
		break;
	case	2:
		service = argv[1];
		break;
	default:
		errexit("usage: TCPechod [port]\n");
	}

	if (WSAStartup(WSVERS, &wsadata) != 0)
		errexit("WSAStartup failed\n");

	msock = passiveUDP(service);
	
	while (1) {
		alen = sizeof(fsin);
		int cBytes = recvfrom(msock, buf, BUFSIZE, 0, (struct sockaddr *)&fsin, &alen);
		if (SOCKET_ERROR == cBytes)
			errexit("recvfrom: error number\n", GetLastError());
		int cBytesSent = sendto(msock, buf, cBytes, 0, (struct sockaddr *)&fsin, alen);
		if (SOCKET_ERROR == cBytesSent)
			errexit("sendto: error number\n", GetLastError());
	}
	return 1;	/* not reached */
}
